import java.net.*; 
import javax.swing.JOptionPane; 
 
public class UDPReceive extends Thread { 
    String receivedMessage; 
    String sentMessage; 
    byte[] buffer = new byte[1024]; 
    DatagramSocket datagramSocket; 
    DatagramPacket datagramPacket = new DatagramPacket(buffer, buffer.length); 
 
    MainFrame mainFrame; 
 
    public UDPReceive(DatagramSocket ds, MainFrame mf) { 
        this.datagramSocket = ds;
        this.mainFrame = mf;
    } 
 
    public UDPReceive(DatagramSocket ds, MainFrame mf, String msgSend) { 
        this.datagramSocket = ds; 
        this.mainFrame = mf; 
        this.sentMessage = msgSend; 
    } 
 
    public void run() { 
        while (true) { 
            try { 
            	datagramSocket.receive(datagramPacket); 
                receivedMessage = new String(datagramPacket.getData(), datagramPacket.getOffset(), 
                		datagramPacket.getLength()); 
                String Num = receivedMessage.substring(0, 1); 
                receivedMessage = receivedMessage.substring(2); 
 
                String[] address = receivedMessage.split(":"); 
                
                if (Num.equals("0") || Num.equals("1")) { 
                	mainFrame.defaultTableModel.addRow(address); 
 
                    if (Num.equals("0") && !datagramPacket.getAddress().getHostAddress().equals(getLocalAddress())) { 
                        new UDPSend(datagramSocket, "1 " + sentMessage, 
                        		datagramPacket.getAddress().getHostAddress(), 
                        		datagramPacket.getPort(), false).start(); 
                    } 
                } else if (Num.equals("2")) { 
                    int result = JOptionPane.showConfirmDialog(null, 
                            address[0] + " asks for a chat\nAccept?", "Message", 
                            JOptionPane.YES_NO_OPTION); 
 
                    new UDPSend(datagramSocket, "3 " + result, address[0], 
                                    Integer.parseInt(address[1]), false).start();  
                    if (result == 0) { 
                    	mainFrame.chatManager.setDestAddressAndPort(address[0], 
                                Integer.parseInt(address[1]), 
                                Integer.parseInt(address[2]), 
                                Integer.parseInt(address[3]), 
                                Integer.parseInt(address[4]), 
                                Integer.parseInt(address[5]) 
                                ); 
                        String strResult = mainFrame.chatManager.startAudioTransmit();
                        
                        if(strResult != null){
                        	JOptionPane.showMessageDialog(null, "Error: " + result);
                        }
                        
                        mainFrame.connectButton.setEnabled(false); 
                        mainFrame.multicastButton.setEnabled(false); 
                        mainFrame.disconnectButton.setEnabled(true); 
                        mainFrame.videoButton.setEnabled(true); 
                    } 
                } else if (Num.equals("3")) { 
                    if (receivedMessage.equals("1")) { 
                        JOptionPane.showMessageDialog(null, 
                        		datagramPacket.getAddress().getHostAddress() + " refuse to chat"); 
                    } else { 
                    	String result = mainFrame.chatManager.startAudioTransmit();
                        
                        if(result != null){
                        	JOptionPane.showMessageDialog(null, "Error: " + result);
                        }
                        
                        mainFrame.connectButton.setEnabled(false); 
                        mainFrame.multicastButton.setEnabled(false); 
                        mainFrame.disconnectButton.setEnabled(true); 
                        mainFrame.videoButton.setEnabled(true);
                    } 
                } else if (Num.equals("4")) {  
                     
                	mainFrame.defaultTableModel.removeRow( mainFrame.findRow(address[0], address[1]) ); 
                } else { 
                    String addressList[] = receivedMessage.split(" "); 
                    for (int i = 0; i < addressList.length; i++) { 
                        address = addressList[i].split(":");
                        
                        
                        
                        mainFrame.defaultTableModel.addRow(address); 
                    } 
                } 
            } catch (Exception e) { 
                e.printStackTrace(); 
            } 
        } 
    } 
 
    public void deleteTableRow(String name, String address) { 
 
        int rowCount = mainFrame.userTable.getRowCount(); 
        int columnCount = mainFrame.userTable.getColumnCount(); 
 
        for (int i = 0; i < rowCount; i++) { 
            for (int j = 0; j < columnCount; j++) { 
 
                Object value = mainFrame.userTable.getValueAt(i, j); 
                if (name.equals(value)) { 
 
                    for (int k = 0; k < columnCount; k++) { 
                        value = mainFrame.userTable.getValueAt(i, k); 
                        if (address.equals(value)) { 
                        	mainFrame.defaultTableModel.removeRow(i); 
                            return; 
                        } 
                    } 
                } 
            } 
        } 
    } 
 
    public String getLocalAddress() { 
        InetAddress addr = null; 
        try { 
            addr = InetAddress.getLocalHost(); 
        } catch (UnknownHostException ex) { 
        } 
        return addr.getHostAddress(); 
    } 
 
} 


